| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Private Attributes | List of all members
DLLClassManager Class Reference

`#include <src/ApplicationMgr/DLLClassManager.h>`

Inheritance diagram for DLLClassManager:
[legend]
Collaboration diagram for DLLClassManager:
[legend]

## Public Member Functions
| DLLClassManager (IInterface *iface)
StatusCode | loadModule (const std::string &module, bool fireIncident=true) override
StatusCode | queryInterface (const InterfaceID &iid, void **pinterface) override
| implementation of IInterface::queryInterface More...
Public Member Functions inherited from implements< IClassManager >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| implements ()=default
| Default constructor. More...
| implements (const implements &)
| Copy constructor (zero the reference count) More...
implements & | operator= (const implements &)
| Assignment operator (do not touch the reference count). More...
unsigned long | addRef () override
| Reference Interface instance. More...
unsigned long | release () override
| Release Interface instance. More...
unsigned long | refCount () const override
| Current reference count. More...

## Private Attributes
SmartIF< ISvcLocator > | m_svclocator
SmartIF< IMessageSvc > | m_msgsvc
SmartIF< IInterface > | m_pOuter

## Additional Inherited Members
Public Types inherited from implements< IClassManager >
using | base_class = implements< Interfaces... >
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
using | iids = typename extend_interfaces_base::ext_iids
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Attributes inherited from implements< IClassManager >
std::atomic_ulong | m_refCount
| Reference counter. More...

## Detailed Description

Definition at line 28 of file DLLClassManager.h.

## Constructor & Destructor Documentation

## ◆ DLLClassManager()

DLLClassManager::DLLClassManager | ( | IInterface * | iface | ) |

Definition at line 20 of file DLLClassManager.cpp.

20 {
21 m_pOuter = iface;
22 m_svclocator = m_pOuter;
23
24 assert( m_svclocator.isValid() );
25
26 addRef(); // Initial count set to 1
27 }
SmartIF::isValid
bool isValid() const
Allow for check if smart pointer is valid.
Definition: SmartIF.h:62
implements< IClassManager >::addRef
unsigned long addRef() override
Reference Interface instance.
Definition: implements.h:38
DLLClassManager::m_svclocator
SmartIF< ISvcLocator > m_svclocator
Definition: DLLClassManager.h:40
DLLClassManager::m_pOuter
SmartIF< IInterface > m_pOuter
Definition: DLLClassManager.h:42

## Member Function Documentation

## ◆ loadModule()

StatusCode DLLClassManager::loadModule | ( | const std::string & | module,
|  | bool | fireIncident = `true`
| ) |  |
| override

Definition at line 30 of file DLLClassManager.cpp.

30 {
31 // Access the message service if not yet done already
32 if ( !m_msgsvc ) m_msgsvc = m_svclocator;
33 MsgStream log( m_msgsvc, "DllClassManager" );
34
35 std::string mod = module == "" ? System::moduleNameFull() : module;
36 if ( module == "NONE" ) return StatusCode::SUCCESS;
37
38 void* libHandle = nullptr;
39 StatusCode status = StatusCode::FAILURE;
40 try {
41 status = System::loadDynamicLib( module, &libHandle ) ? StatusCode::SUCCESS : StatusCode::FAILURE;
42 } catch ( const std::exception& excpt ) {
43 if ( m_msgsvc ) { log << MSG::ERROR << "Exception whilst loading " << module << " : " << excpt.what() << endmsg; }
44 status = StatusCode::FAILURE;
45 }
46
47 if ( status.isFailure() ) {
48 // DLL library not loaded
49 log << MSG::ERROR << "Could not load module " << module << endmsg;
50 log << MSG::ERROR << "System Error: " << System::getLastErrorString() << endmsg;
51 return StatusCode::FAILURE;
52 }
53 // FIXME this is a hack to avoid a very early call to moduleLoad from
54 // FIXME AppMgr::i_startup
55 if ( fireIncident && !module.empty() ) {
56 // now fire ModuleLoadedIncident
57 const bool CREATEIF( true );
58 auto pIncidentSvc = m_svclocator->service<IIncidentSvc>( "IncidentSvc", CREATEIF );
59 if ( !pIncidentSvc ) {
60 log << MSG::FATAL << "Can not locate IncidentSvc" << endmsg;
61 throw GaudiException( "Error retrieving IncidentSvc", "DLLClassManager::DLLClassManager", StatusCode::FAILURE );
62 }
63 pIncidentSvc->fireIncident( ModuleLoadedIncident( "DLLClassManager", module ) );
64 }
65
66 return StatusCode::SUCCESS;
67 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
std::string::empty
T empty(T... args)
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:21
System::moduleNameFull
GAUDI_API const std::string & moduleNameFull()
Get the full name of the (executable/DLL) file.
Definition: ModuleInfo.cpp:77
Gaudi.CommonGaudiConfigurables.mod
mod
Definition: CommonGaudiConfigurables.py:22
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
std::string
STL class.
MSG::FATAL
Definition: IMessageSvc.h:15
ISvcLocator::service
StatusCode service(const Gaudi::Utils::TypeNameString &name, T *&svc, bool createIf=true)
Templated method to access a service by name.
Definition: ISvcLocator.h:76
std::exception::what
T what(T... args)
DLLClassManager::m_msgsvc
SmartIF< IMessageSvc > m_msgsvc
Definition: DLLClassManager.h:41
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
ModuleLoadedIncident
fired when a module (DLL) is loaded
Definition: ModuleIncident.h:43
std::exception
STL class.
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
MSG::ERROR
Definition: IMessageSvc.h:15
DLLClassManager::m_svclocator
SmartIF< ISvcLocator > m_svclocator
Definition: DLLClassManager.h:40
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
System::getLastErrorString
GAUDI_API const std::string getLastErrorString()
Get last system error as string.
Definition: System.cpp:262
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
IIncidentSvc
The interface implemented by the IncidentSvc service.
Definition: IIncidentSvc.h:23
Gaudi.Configuration.log
log
Definition: Configuration.py:13
System::loadDynamicLib
GAUDI_API unsigned long loadDynamicLib(const std::string &name, ImageHandle *handle)
Load dynamic link library.
Definition: System.cpp:135

## ◆ queryInterface()

StatusCode DLLClassManager::queryInterface | ( | const InterfaceID & | iid,
|  | void ** | pinterface
| ) |  |
| override

implementation of IInterface::queryInterface

Definition at line 70 of file DLLClassManager.cpp.

70 {
71 // try local interfaces
72 StatusCode sc = base_class::queryInterface( iid, pinterface );
73 if ( sc.isSuccess() ) return sc;
74 // fall back on the owner
75 return m_pOuter->queryInterface( iid, pinterface );
76 }
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
implements::queryInterface
StatusCode queryInterface(const InterfaceID &ti, void **pp) override
Implementation of IInterface::queryInterface.
Definition: implements.h:20
DLLClassManager::m_pOuter
SmartIF< IInterface > m_pOuter
Definition: DLLClassManager.h:42
IInterface::queryInterface
virtual StatusCode queryInterface(const InterfaceID &ti, void **pp)=0
Set the void** to the pointer to the requested interface of the instance.

## Member Data Documentation

## ◆ m_msgsvc

SmartIF<IMessageSvc> DLLClassManager::m_msgsvc
| private

Definition at line 41 of file DLLClassManager.h.

## ◆ m_pOuter

SmartIF<IInterface> DLLClassManager::m_pOuter
| private

Definition at line 42 of file DLLClassManager.h.

## ◆ m_svclocator

SmartIF<ISvcLocator> DLLClassManager::m_svclocator
| private

Definition at line 40 of file DLLClassManager.h.

The documentation for this class was generated from the following files:

- GaudiCoreSvc/src/ApplicationMgr/DLLClassManager.h
- GaudiCoreSvc/src/ApplicationMgr/DLLClassManager.cpp